Subject: Re: [PATCH] NETLINK_UESTABLISHED notifier event

From: Dmitry Yusupov <[email-masked]>
Date: Thu, 07 Apr 2005 16:36:41 -0700

On Fri, 2005-04-08 at 07:32 +1000, Herbert Xu wrote:
> On Wed, Apr 06, 2005 at 03:26:25PM -0700, Dmitry Yusupov wrote:
> > 
> > Messages from kernel are asynchronous and there are no alloc_skb on "up"
> > calls. It is "mempooled out" on interface level. (see Open-iSCSI
> > interface). Messages to kernel requires copy_from_user to newly
> > allocated skb, here is where we need sk_allocation bit set. Those
> > messages are synchronous from daemon perspective. If "down" call fails,
> > we will re-try later or take some other management action. We assuming
> > that later OOM-killer will free some memory for us and atomic allocation
> > will succeed eventually.
> 
> I presume you only need to send one message at a time of a fixed size.
> Would it better to always have an skb allocated for the socket so that
> we don't need to allocate at sendmsg time?

This actually even better since we will guarantee "down" call delivery.
My only concern is that it is not very generic. Do you know clean way to
implement it?